/*
BigBarChart master functions
LP July 2014
Cleaning up the BigBarChart code so it just does the master stuff (not slave stuff)
Needs to:
--collect button inputs
--send button inputs to python
--parse python data and send out the arduino slaves

NOTE: turn off the serial reset on arduino!!
http://playground.arduino.cc/Main/DisablingAutoResetOnSerialConnection

*/ 
//////////////////////////////-----------------------------------////////////////////

//Pull in necessary libraries
#include "Wire.h"
#include "BlinkM_funcs.h"
#include <avr/pgmspace.h>  // for progmem stuff
//for waiting for info from python

#define FALSE 0
#define TRUE 1
#define MAX_LINE 20

//Define all the pins
int motorPin[2]={3, 11};
//button pins: three for lights and two for motors
const int buttonPin[5]={2, 4, 9, 10, 12};
//NEW BUTTON PIN MAPPING: 2 buttons for time and 3 buttons for chemical

//ledPin: two for motors; the variable lights will just be BlinkMMax
int ledPin[2]={5, 6};




//////////// ------------------ DECLARE VARIABLES

//line available stuff--how much info to wait for from python
char line[MAX_LINE + 1];

//NETWORKING
//byte blinkm_addr = 0x09; // the default address of all BlinkMs
byte blinkm_addr;
//byte arduino_addr = 0x2A; //arduino slave is at 42 (which is this in hex)
byte arduino_addr;

//BLINKMMAX
// set this if you're plugging a BlinkM directly into an Arduino,
// into the standard position on analog in pins 2,3,4,5
// otherwise you can set it to false or just leave it alone
const boolean BLINKM_ARDUINO_POWERED = false;

//MOTORS
//starting value for controlling the duty cycle
//incremented with the button--126 gives start value of 23
int OCR2Bcounter = 126;
//this is turned into a value in the right range
int OCR2Bvalue = 23;
int OCR2Avalue = 253;
//Set the fast and slow values: direction is also tied up in this too.
int OCR2Bslow = 21;
int OCR2Bfast = 27;
int OCR2Bstop = 24;
//22, 26, 24 works
//WILL NEED TO REVISE THESE VALUES
int OCR2Bforwards = 21;
int OCR2Bbackwards = 27;
//starts us at 24/254 = 9.4% (theoretically, but a bit off?)
//Runtimes give the end of the time slot order
//e.g. 0-1000 off; 1000-3000 slow; 3000-4000 off; 4000-7000 fast;
unsigned long stopRunTime = 1000;
unsigned long slowRunTime = 3000;
unsigned long secondStopRunTime = 4000;
unsigned long fastRunTime = 6999;
unsigned long totalTime = fastRunTime + 1;


//3 NETWORKING & 2 MOTORS BUTTONS
int last_state[5] = {0, 0, 0, 0, 0};
int buttonPushCounter[5] = {0, 0, 0, 0, 0};
boolean buttonState[5] = {0, 0, 0, 0, 0};
boolean lastButtonState[5] = {0, 0, 0, 0, 0};
boolean lightState[3] = {0, 0, 0}; //these are the three blinkMMax lights, not the networked arduino
boolean ledState[3] = {0, 0, 0};
long debounceDelay = 200;
long lastDebounceTime = 0;
int buttonSend = 0;
int oldButtonSend = 0;

//TIME 
unsigned long currentMillis = 0;
unsigned long startMillis = 0;
unsigned long motorStartMillis = 0;

//SERIAL STUFF
int pythonVal = 9999;
int nrow= 1; //number of rows in the data that will be sent
int i;
int j;

/////////////////////////////// RUN THINGS;

void setup()
{
  
  //debugging light
pinMode(7, OUTPUT);



  //set up serial and networking stuff
  networkingSetup();
  delay(500);

  //input the number of motor pins
  for (int i=0; i<2; i++)
  motorSetup(motorPin[i]);
  
  //input the number of buttons
  for (int i=0; i<5; i++)
  buttonArraySetup(buttonPin[i]);
  
  //input the number of LEDs
  for (int i=0; i<2; i++)
  ledSetup(ledPin[i]);

  blinkStart();
  
  /*
  BlinkM_setRGB(0, 254, 0, 254);
  delay(600);
  BlinkM_setRGB(11, 0, 0, 0);
  delay(600);
  BlinkM_setRGB(12, 0, 254, 0);
  delay(600);
  BlinkM_setRGB(13, 0, 0, 254);
  delay(600);
  BlinkM_setRGB(14, 254, 0, 0);
  delay(600);
  */
  
  arduinoLEDSendDirect(0, 254, 254, 254);
  delay(1000);
  arduinoLEDSendDirect(0, 0, 254, 254);
  delay(1000);
  arduinoLEDSendDirect(0, 254, 0, 254);
  delay(1000);
  arduinoLEDSendDirect(0, 254, 254, 0);
  delay(1000);

  
while (shouldButtonSend(buttonState)==false){ 
  while (arrayCompare(buttonState, lastButtonState, 5, 5)){
    for (int i=0; i<5; i++){
      buttonState[i] = buttonReadShort(i);
    //Serial.println("cow");
    //Serial.print(buttonState[i]);
    }
    //Serial.println();
  }
}

arrayReplaceBoolean(lastButtonState, buttonState, 5, 5);

//Serial.print("hi");
}


boolean buttonCheck = 0;
boolean eol = false;


void loop()
{
//NEW MASTER
//Task is to get button data in and send out loads of data from python to everyone else
  
  //Read the 5 pins until one of them changes
  while (arrayCompare(buttonState, lastButtonState, 5, 5)){ 
    for (int i=0; i<5; i++){
      buttonState[i] = buttonReadShort(i);
    //Serial.println("cow");
    //Serial.print(buttonState[i]);
    }
    //Need a delay here or things get thrown off and the buttons aren't read correctly!!!!
    delay(100);
  }


  arrayReplaceBoolean(lastButtonState, buttonState, 5, 5);

//Serial.println(shouldButtonSend(buttonState)); 
//Serial.println("end");



//See if this is a legit button value--if the one value for each set hasn't been selected we don't want to update anything or send anything
//if it is send-able, do a lot of things...
  if (shouldButtonSend(buttonState)) {
    

  //Turn this into a two digit number to send, saying which buttons are on, and send it.
  buttonToPython(buttonState);
  
    
     
  //Wait for response (and get it in the line variable)
  
  /* check to see if we are getting anything to read
  int a = Serial.available();
  for (int i=0; i<(a); i++){
  digitalWrite(13, HIGH);
  delay(1000);
  digitalWrite(13, LOW);
  delay(1000);  
  }
  */
 
 //Reset the row counter
 j=0; 
 
 //Sending a number of rows; go through this loop and keep waiting until we send all of them
  //we know the dataset will have X rows (bars), so make sure we read all those lines and act before listening again

 while (j<(2*nrow)){  
 while (!lineAvailable(MAX_LINE,line))  // until a line has been read
  {;}  // do nothing
   
  //eventually send all the motor and led data to the networked arduinos
  //Send the LED data (and the start of sending the motor data
   pythonToSlaves();
   
   //pinMode(8, OUTPUT);
   //digitalWrite(8,1);
  
  //N.B don't use serial print because python hears that

//arduinoMotorSend(byte arduinoAddr, boolean motorDirection, int motorTime) gets this data and picks the parts we need to send to the motors
//pythonData is the pointer than sets up the data (check how this works with serial and what length it expects!)
//sending executed here
//  motorPython();

//increment the times through (until it's more than the number of rows
 j++;
 } //end the row while loop

  
  } //ends the check if it's sendable
  

  
  //Go back to the top and start waiting for the buttons to change...
  

}




