/*Started by Dayanna 07/09/2014.
Added to and modified by Laura
General functions for converting types, dropping parts, and cleaning stuff up
*/  


//////////////////////////////
//Compare two arrays
//From http://forum.arduino.cc/index.php/topic,5157.0.html

boolean arrayCompare(boolean *a, boolean *b, int len_a, int len_b){
      int n;

      // if their lengths are different, return false
      if (len_a != len_b) return false;

      // test each element to be the same. if not, return false
      for (n=0;n<len_a;n++) if (a[n]!=b[n]) return false;

      //ok, if we have not returned yet, they are equal :)
      return true;
}

//////////////////////////////
//Replace one array with another
//a is old array b is new array
void arrayReplaceBoolean(boolean *a, boolean *b, int len_a, int len_b){
      int n;

      // if their lengths are different, don't do anything (really should be error
      if (len_a != len_b) 
        Serial.println("array error");

      // replace each element
      for (n=0;n<len_a;n++)  
        (a[n]=b[n]);

}


///////////////////////////////////////////
//change and int over serial to return as a boolean
boolean intToBoolSerial(int val){
  
  boolean result;
  
  if (Serial.available()) {
    val = Serial.read();//// read the serial port
    //val.trim();
      if (val == '0'){
        result = Serial.println(FALSE);
        return result;
      }
      
      else{
        result=Serial.println(TRUE);
        return result;
      }
  }
}  
///////////////////////////////////////////////////////////////////
//Generally change an integer to a boolean
boolean intToBool(int val){  
  boolean result;
      if (val == 0){
        result = FALSE;
        return result;
      }
      
      else if (val == 1){
        result=TRUE;
        return result;
      }
      else {
        return(-1);
      }
  }

////////////////////////////////////////////////////////////////
//Change an integer to a byte...TO BE DONE
byte intToByte(int val){
  digitalWrite(13, HIGH);
}

///////////////////////////////////////////////////////////////////
//Change the integers sent for the LEDs from integers to booleans
//1 is on, 2 is off, 0 is no change--but we shouldn't get zeros b/c of if loop
boolean intToBoolLed(int val){  
  boolean result;
      if (val == 2){
        result = FALSE;
        return result;
      }
      
      else if (val == 1){
        result=TRUE;
        return result;
      }
      else {
        return(-1);
      }
  }




///////////////////////////////////////////////////////////////////////////////////////////////////////


unsigned int charToInt(int val){
  
  char incomingByte;
  unsigned int integerValue=0; 
  
  if (Serial.available() > 0) {   // something came across serial
    integerValue = 0;         // throw away previous integerValue
    while(1) {            // force into a loop until 'n' is received
      incomingByte = Serial.read();
      if (incomingByte == '\n') break;   // exit the while(1), we're done receiving
      if (incomingByte == -1) continue;  // if no characters are in the buffer read() returns -1
      integerValue *= 10;  // shift left 1 decimal place
      // convert ASCII to integer, add, and shift left 1 decimal place
      integerValue = ((incomingByte - 48) + integerValue);
    }
    return Serial.println(integerValue); 
    
  }
}

//////////////////////////////////////////////////////////////////////////////////////////////////////////

  //boolean int_to_bool;
  //int_to_bool= intToBool(0);
  //unsigned int number;
  //number= charToInt(0);

/////////////////////////////////////////////////////////////////////////////////////////////////////////////

unsigned int charToIntStore(){
  
  char incomingByte;
  unsigned int integerValue=0; 
  
  if (Serial.available() > 0) {   // something came across serial
    integerValue = 0;         // throw away previous integerValue
    while(1) {            // force into a loop until 'n' is received
      incomingByte = Serial.read();
      if (incomingByte == '\n') break;   // exit the while(1), we're done receiving
      if (incomingByte == -1) continue;  // if no characters are in the buffer read() returns -1
      integerValue *= 10;  // shift left 1 decimal place
      // convert ASCII to integer, add, and shift left 1 decimal place
      integerValue = ((incomingByte - 48) + integerValue);
    }
    return integerValue; 
    
  }
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////

unsigned int charToIntStringStore(){
  //Here we're getting a nine digit string from arduino
  //We want each of the chunks to split up to different variables to do different things
  //parts are: arduino ID (2), direction (1), time (3), leds (3)
  
  char incomingByte;
  unsigned int integerValue=0; 
  int count = 0;
  int arduinoVal = 0;
  int motorDirectionVal = 0;
  int motorTimeVal  = 0;
  int ledVal = 0;
    
//Only do this when we get something from the serial
  if (Serial.available()> 0) {
  //Get the arduino number we're talking to
  while (count < 2){  
      incomingByte = Serial.read();
      if (incomingByte == '\n') break;   // exit the while(1), we're done receiving
      if (incomingByte == -1) continue;  // if no characters are in the buffer read() returns -1
      arduinoVal *= 10;  // shift left 1 decimal place
      // convert ASCII to integer, add, and shift left 1 decimal place
      arduinoVal = ((incomingByte - 48) +arduinoVal);
      //arduinoVal = count;
      count = count +1;
    }
    
  //Get the motor direction
   while (count < 3){
      incomingByte = Serial.read();
      if (incomingByte == '\n') break;   // exit the while(1), we're done receiving
      if (incomingByte == -1) continue;  // if no characters are in the buffer read() returns -1
      motorDirectionVal *= 10;  // shift left 1 decimal place
      // convert ASCII to integer, add, and shift left 1 decimal place
      motorDirectionVal = ((incomingByte - 48) + motorDirectionVal);
      count = count +1;
    }
    
   //Get the motor time 
   while (count < 6){
      incomingByte = Serial.read();
      if (incomingByte == '\n') break;   // exit the while(1), we're done receiving
      if (incomingByte == -1) continue;  // if no characters are in the buffer read() returns -1
      motorTimeVal *= 10;  // shift left 1 decimal place
      // convert ASCII to integer, add, and shift left 1 decimal place
      motorTimeVal = ((incomingByte - 48) + motorTimeVal);
      count = count +1;
    }
    
    //Get the last three digits--should hit the newline
   while (1) {
      incomingByte = Serial.read();
      if (incomingByte == '\n') break;   // exit the while(1), we're done receiving
      if (incomingByte == -1) continue;  // if no characters are in the buffer read() returns -1
      ledVal *= 10;  // shift left 1 decimal place
      // convert ASCII to integer, add, and shift left 1 decimal place
      ledVal = ((incomingByte - 48) + ledVal);
      count = count +1;
    }
    
  
  if (arduinoVal >0) Serial.println(arduinoVal);
  if (motorDirectionVal >0) Serial.println(motorDirectionVal);
  if (motorTimeVal) Serial.println(motorTimeVal);
  if (ledVal) Serial.println(ledVal);
  }
}



